
function createMenu(){
    const container = document.getElementById('gn-menu');
    addClass(container, "gn-menu-main");
    container.innerHTML = `<li class="gn-trigger">
            <a class="gn-icon gn-icon-menu gn-open-part"><span>Menu</span></a>
            <nav class="gn-menu-wrapper">
                <div class="gn-scroller">
                    <ul class="gn-menu">
                        <!--<li class="gn-search-item">-->
                        <!--<input placeholder="Search" type="search" class="gn-search">-->
                        <!--<a class="gn-icon gn-icon-search"><span>Search</span></a>-->
                        <!--</li>-->
                        <li><a class="gn-icon gn-icon-archive" href="/#main">Home</a></li>
                        <li><a class="gn-icon gn-icon-archive" id="game-rules" onclick="getWikiLink()">Game Rules</a></li>
                        <li><a class="gn-icon gn-icon-archive" href="/howtoplay.html">Tutorial</a></li>
                        <li><a class="gn-icon gn-icon-cog" href="/#gamelist">Game</a>
<!--                            <ul class="gn-submenu">-->
<!--                                <li><a class="gn-icon gn-icon-videos">Chinese Chess</a></li>-->
<!--                                <li><a class="gn-icon gn-icon-videos">Chess</a></li>-->
<!--                                &lt;!&ndash;<li><a class="gn-icon gn-icon-pictures">Go</a></li>&ndash;&gt;-->
<!--                            </ul>-->
                        </li>
                        <li><a class="gn-icon gn-icon-article" href="/#terms">Terms of Service</a></li>
                        <li><a class="gn-icon gn-icon-article" href="/#policy">Privacy Policy</a></li>
                        <li><a class="gn-icon gn-icon-article" href="/faq.html">Frequently Asked Questions (FAQ)</a></li>
                        <li><a class="gn-icon gn-icon-help" href="/#contact">Contact</a></li>
                    </ul>
                </div><!-- /gn-scroller -->
            </nav>
        </li>`;
}

function getWikiLink(){
    const lang = localStorage.getItem('lang') || 'en';
    if(lang == 'en') {
        window.location.href = "/webviewer.html?url=https://en.wikipedia.org/wiki/Xiangqi";
        return;
    }
    readTextFile('cc_WikiLinks.html', function (links) {
        const link_dict = JSON.parse(links)
        console.log(link_dict)
        let link = null;
        try {
            link = link_dict.get(lang);
        } catch {
            link = 'https://en.wikipedia.org/wiki/Xiangqi';
        }
        window.location.href = "/webviewer.html?url=" + link;
    });
}
// Add a class to the element
function addClass(element, className) {
    if (!element.classList.contains(className)) {
        element.classList.add(className);
    }
}
function validateEmail(email) {
    var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(String(email).toLowerCase());
}

function scrollTo(hash) {
// Using jQuery's animate() method to add smooth page scroll
    // The optional number (400) specifies the number of milliseconds it takes to scroll to the specified area
    $('html, body').animate({
        scrollTop: $(hash).offset().top
    }, 400, function () {

        // Add hash (#) to URL when done scrolling (default click behavior)
        window.location.hash = hash;
    });
}

$(document).ready(function () {
    // Add smooth scrolling to all links
    $("a").on('click', function (event) {
        if (this.hash !== "") {
            event.preventDefault();
            var hash = this.hash;
            scrollTo(hash);
            window.gnMenu.closeMenu();
        }
    });
});

async function translate(text, targetLanguage) {
    const url = `https://translate.google.com/?sl=auto&tl=${targetLanguage}&text=${encodeURIComponent(text)}`;
    const response = await fetch(url);
    const html = await response.text();
    const parser = new DOMParser();
    const doc = parser.parseFromString(html, 'text/html');
    const result = doc.querySelector('.tlid-translation.translation').textContent;
    return result;
}

function changeLanguage(lang) {
    localStorage.setItem('lang', lang);
    localizeTexts();
    runTrans();
    let ui = new firebaseui.auth.AuthUI(firebase.auth());
    ui.setLanguage(lang);
    ui.start('#firebaseui-auth-container', uiConfig);
}
menu = null;
function init() {
    createMenu();
    menu = new gnMenu(document.getElementById('gn-menu'));
    document.getElementById("lang-select").value = lang;
    // Get the current URL query string
    var queryString = window.location.search;
    var urlParams = new URLSearchParams(queryString);
    var on_mobile = urlParams.get('mobile');
    var lang = urlParams.get('lang');
    var game = urlParams.get('game');
    var audio = urlParams.get('audio');
    var scroll = urlParams.get('scroll');
    var gameSetParam = urlParams.get('gameSetParam');
    if(!game) {
        game = localStorage.getItem('game');
    }
    // if(game){
    //     $('.gameitem').each(function (index) {
    //         var id = $(this).attr('id');
    //         if (id == game) {
    //             $(this).removeClass('hidden');
    //         } else {
    //             $(this).addClass('hidden');
    //         }
    //     });
    // }
    if (gameSetParam) {
        localStorage.setItem('mobile', on_mobile)
        localStorage.setItem('audio', audio)
        if (!localStorage.getItem('lang') && lang)
            localStorage.setItem('lang', lang)
        if (game) {
            localStorage.setItem('game', game)
        }
        localStorage.setItem('prod', 1);
        if (scroll) {
            scrollTo('#' + scroll);
        }
    }
}